<?php

namespace CustomerManagement\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SetUnsetEvents StructType
 * @subpackage Structs
 */
class SetUnsetEvents extends AbstractStructBase
{
    /**
     * The Error
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $Error;
    /**
     * The ErrorMessage
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ErrorMessage;
    /**
     * The History
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \CustomerManagement\ArrayType\ArrayOfEventDatetimePair
     */
    public $History;
    /**
     * Constructor method for SetUnsetEvents
     * @uses SetUnsetEvents::setError()
     * @uses SetUnsetEvents::setErrorMessage()
     * @uses SetUnsetEvents::setHistory()
     * @param bool $error
     * @param string $errorMessage
     * @param \CustomerManagement\ArrayType\ArrayOfEventDatetimePair $history
     */
    public function __construct($error = null, $errorMessage = null, \CustomerManagement\ArrayType\ArrayOfEventDatetimePair $history = null)
    {
        $this
            ->setError($error)
            ->setErrorMessage($errorMessage)
            ->setHistory($history);
    }
    /**
     * Get Error value
     * @return bool
     */
    public function getError()
    {
        return $this->Error;
    }
    /**
     * Set Error value
     * @param bool $error
     * @return \CustomerManagement\StructType\SetUnsetEvents
     */
    public function setError($error = null)
    {
        // validation for constraint: boolean
        if (!is_null($error) && !is_bool($error)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($error, true), gettype($error)), __LINE__);
        }
        $this->Error = $error;
        return $this;
    }
    /**
     * Get ErrorMessage value
     * @return string|null
     */
    public function getErrorMessage()
    {
        return $this->ErrorMessage;
    }
    /**
     * Set ErrorMessage value
     * @param string $errorMessage
     * @return \CustomerManagement\StructType\SetUnsetEvents
     */
    public function setErrorMessage($errorMessage = null)
    {
        // validation for constraint: string
        if (!is_null($errorMessage) && !is_string($errorMessage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($errorMessage, true), gettype($errorMessage)), __LINE__);
        }
        $this->ErrorMessage = $errorMessage;
        return $this;
    }
    /**
     * Get History value
     * @return \CustomerManagement\ArrayType\ArrayOfEventDatetimePair|null
     */
    public function getHistory()
    {
        return $this->History;
    }
    /**
     * Set History value
     * @param \CustomerManagement\ArrayType\ArrayOfEventDatetimePair $history
     * @return \CustomerManagement\StructType\SetUnsetEvents
     */
    public function setHistory(\CustomerManagement\ArrayType\ArrayOfEventDatetimePair $history = null)
    {
        $this->History = $history;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \CustomerManagement\StructType\SetUnsetEvents
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
